<template>
  <div style="margin:0rem 5rem 3rem" >
    <el-row v-for="(mat, index) in contractsMovement" :key="index" >
      <el-col :span="24" class="box-historial" style="padding: 70px 50px 30px; margin-top: 5rem">
        <el-row style="margin-bottom: 2rem">
          <el-col :span="6" :offset="18">
              <span class="text-orange text-bold fonts-bold-general text-bold"> N° DE MOVIMIENTO: </span>
              <span class="text-bold text-orange" style="padding-left:15px">  {{  mat.movementNumber }} </span>
          </el-col>
        </el-row>
        <el-row style="margin-bottom: 1rem" >
          <el-col :span="11">
            <el-row >
              <el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general text-bold"> Proveedor: </span>
                <span > {{  mat.contractName }} </span>
              
              </el-col>
              <el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general text-bold"> Cod Proveedor:</span>
                <span >  {{  mat.providerCode }} </span>
              </el-col>
            </el-row>
          </el-col>
          <el-col :span="7">
            <div >
              <el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general text-bold"> Cod. Registro: </span>
                <span>  {{  mat.contractCode }} </span>
              </el-col>
              <el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general text-bold">N° Contr. Distribuidor:</span>
                <span> {{ mat.contratoDistribuidor }} </span>
              </el-col>
            </div>
          </el-col>
          <el-col :span="6">
            <div >
              <el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general text-bold"> Fecha: </span>
                <span > {{  new Date(mat.registrationDate).toLocaleDateString('en-GB') }} </span>
              </el-col>
            </div>
          </el-col>
        </el-row>
        <el-table style="margin-top: 2.5rem" class="tableMovement"
          :header-cell-class-name="tableRowClassName"
          border
          :data="mat.materialsRegistration">
          <el-table-column
            prop="codMaterial"
            label="Cod. Material"
            >
          </el-table-column>
          <el-table-column
            :label="'Titúlo Orginal'">
            <template slot-scope="scope">
              <p>{{scope.row.refMaterials.originalTitle}}</p>
            </template>
          </el-table-column>

          <el-table-column
            label="Titúlo">
            <template slot-scope="scope">
              <p>{{scope.row.refMaterials.listTitle}}</p>
            </template>
          </el-table-column>

          <el-table-column
            label="Posición en el contrato">
            <template slot-scope="scope">
              <p>{{ scope.row.refMaterials.orderPosition }}</p>
            </template>
          </el-table-column>

          <el-table-column 
            prop="typeOfContent"
            label="Tipo de Cont.">
          </el-table-column>
          <el-table-column
            width="100"
            prop="numberCap"
            label="N° Cap." >
          </el-table-column>

          <el-table-column
            width="100"
            label="Soporte de llegada" >
            <template slot-scope="scope">
              <p>{{ arrivalSupportInfo(scope.row.refMaterials, mat.materialsRegistration[0].numberCap, mat.materialsRegistration) }}</p>
            </template>
          </el-table-column>

          <el-table-column
            width="100"
            label="Modo de Envío" >
            <template slot-scope="scope">
              <p>{{ shippingModeInfo(scope.row.refMaterials, mat.materialsRegistration[0].numberCap) }}</p>
            </template>
          </el-table-column>

          <el-table-column
            width="100"
            prop="guideNumber"
            label="Número de Guía">
              <template slot-scope="scope">
              <p>{{ guideNumberInfo(scope.row.refMaterials, mat.materialsRegistration[0].numberCap) }}</p>
            </template>
          </el-table-column>

          <el-table-column
            width="100"
            prop="currencySymbol"
            label="Moneda" >
          </el-table-column>
          <el-table-column 
            label="Valor Capítulo">
            <template slot-scope="scope">
              <p>{{ getFormat(scope.row.unitPrice) }}</p>
            </template>
          </el-table-column> 
        </el-table>
        <el-row style="margin:2rem 0 1rem">
          <el-col :span="6" :offset="1" class=" text-bold"> <p> N° DE CAPITULOS: <span> <span style="padding-left:1rem">  </span> {{ mat.materialsRegistration.length }} </span></p></el-col>
          <el-col :span="7" :offset="10" class=" text-bold"> <p>IMPORTE TOTAL: <span> <span style="padding-left:1rem">  </span> {{mat.currencySymbol}} {{ getFormat(getSumPriceTotal(mat.materialsRegistration) )}} </span></p></el-col>
        </el-row>
      </el-col>
    </el-row> 
    <el-row style="margin:5rem 0; font-size: 18px" class="text-orange text-bold">
      <el-col :span="6" :offset="2" > <p> TOTAL DE CAPITULOS: <span style="margin-left: 15px"> {{ totalCap }} </span></p></el-col>
      <el-col :span="7" :offset="8" > <p> TOTAL GENERAL: <span style="margin-left: 15px"> {{contractsMovement[0].currencySymbol}} {{ totalGeneral }} </span></p></el-col>
    </el-row>
  </div>
</template> 

<script>
  import { convertNumberFormatUsd } from '../../utils/calculateTime.js'

  export default {
    data () {
      return {
        contractsMovement: []
      }
    },
    created () {
       this.getFiltersMovement()
    },
    methods: {
      getSumPriceTotal (array) {
        let priceTotal = 0
        let newArr = array.filter((el) => el.unitPrice != 'Cortesía')
        newArr.map((el, i ) => {
          priceTotal += el.unitPrice
        })
        return priceTotal
      },
      getFormat (valor) {
        if (valor != 'Cortesía') {
          return convertNumberFormatUsd(valor)
        }
        else {
          return valor
        }
      },
      tableRowClassName ({row, rowIndex}) {
        if (rowIndex === 0) {
          return 'bg-light-red';
        }
      },
      getFiltersMovement () {
        let filter = this.$localStorage.get('filterPrint')
        if ( filter == 'filterNumberMovement' ) {
          this.contractsMovement = this.$store.getters.filterNumberMovement
        }
        else {
          this.contractsMovement = this.$store.getters.limitMovementTenRegisters
        }
      },
      arrivalSupportInfo(data, mat, info) {
        const {numChapters, movementData, infoSupport} = data
        if(numChapters.length > 0) {
          let chap = movementData.length > 0 ? movementData[0].filter((e) => e.chapter == mat) : []
          return chap[0] && chap[0].arrivalSupport !== '' ? chap[0].arrivalSupport : ''
        } else {
          return movementData[0] && movementData[0].arrivalSupport  !== '' ? movementData[0].arrivalSupport : ''
        }
      },
      shippingModeInfo(data, mat) {
        const {numChapters, movementData, infoSupport} = data
        if(numChapters.length > 0) {
          let chap = movementData.length > 0 ? movementData[0].filter((e) => e.chapter == mat) : []
          return chap[0] && chap[0].shippingMode !== '' ? chap[0].shippingMode : ''
        } else {
          return movementData[0] && movementData[0].shippingMode  !== '' ? movementData[0].shippingMode : ''
        }
      },
      guideNumberInfo(data, mat) {
        const {numChapters, movementData, infoSupport} = data
        if(numChapters.length > 0) {
          let chap = movementData.length > 0 ? movementData[0].filter((e) => e.chapter == mat) : []
          return chap[0] && chap[0].guideNumber !== '' ? chap[0].guideNumber : ''
        } else {
          return movementData[0] && movementData[0].guideNumber  !== '' ? movementData[0].guideNumber : ''
        }
      },
    },
    computed: {
      totalGeneral () {
      let total = 0
      if (this.contractsMovement.length > 0) {
        this.contractsMovement.map((el, i, arr) => {
          el.materialsRegistration.map((ella) => {
          total +=  ella.unitPrice == "Cortesía" ? 0 : Number(ella.unitPrice)
          })
        })
      }
      return this.getFormat(total)
      },
      totalCap () {
        let total = 0
        if (this.contractsMovement.length > 0) {
          this.contractsMovement.map((el, i, arr) => {
            total +=  el.materialsRegistration.length
          })
        }
        return total
      }
    }
  }

</script>

<style lang="css">
  .tableMovement .cell {
    word-break: break-word !important;
  }
</style>